function varargout = SphericalTumblerInterface(varargin)
% SPHERICALTUMBLERINTERFACE M-file for SphericalTumblerInterface.fig
%      SPHERICALTUMBLERINTERFACE, by itself, creates a new SPHERICALTUMBLERINTERFACE or raises the existing
%      singleton*.
%
%      H = SPHERICALTUMBLERINTERFACE returns the handle to a new SPHERICALTUMBLERINTERFACE or the handle to
%      the existing singleton*.
%
%      SPHERICALTUMBLERINTERFACE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SPHERICALTUMBLERINTERFACE.M with the given input arguments.
%
%      SPHERICALTUMBLERINTERFACE('Property','Value',...) creates a new SPHERICALTUMBLERINTERFACE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before SphericalTumblerInterface_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to SphericalTumblerInterface_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help SphericalTumblerInterface

% Last Modified by GUIDE v2.5 10-Jun-2008 17:19:58

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @SphericalTumblerInterface_OpeningFcn, ...
                   'gui_OutputFcn',  @SphericalTumblerInterface_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT
end

% --- Executes just before SphericalTumblerInterface is made visible.
function SphericalTumblerInterface_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to SphericalTumblerInterface (see VARARGIN)

% Choose default command line output for SphericalTumblerInterface
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes SphericalTumblerInterface wait for user response (see UIRESUME)
% uiwait(handles.figure1);
end

% --- Outputs from this function are returned to the command line.
function varargout = SphericalTumblerInterface_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
end


% --- Executes on button press in btnConnect.
function btnConnect_Callback(hObject, eventdata, handles)
    % attempt to open serial com port
    global mySerialObj AXIS_MOTOR_ID ROLL_MOTOR_ID CURRENT_BALL_ANGLE CURRENT_AXIS_ANGLE
    CURRENT_BALL_ANGLE = 0;
    CURRENT_AXIS_ANGLE = 0;
    AXIS_MOTOR_ID = 0;
    ROLL_MOTOR_ID = 1;
    
    % Attempt to open the serial port if not already connnected
    portNum = str2double(get(handles.txtComPort, 'string'));
    mySerialObj = MotorControllerConnect(portNum);

    % Check to make sure the serial object is writable
    if (~strcmp(mySerialObj.status, 'open'))
        fprintf('***** ERROR: Could not open serial port object\n');
        fclose(mySerialObj);
        delete(instrfind)
        clear mySerialObj
        return
    else
        % initialize velocity to 1 and 10
        set_mc_velocity(1, AXIS_MOTOR_ID, mySerialObj);
        set_mc_velocity(10, ROLL_MOTOR_ID, mySerialObj);

        % disable connect button
        set([handles.btnConnect, handles.txtComPort], 'Enable', 'off');

        % enable all real time buttons
        set([handles.btnDisconnect, handles.btnSetAxisVelocity,...
             handles.btnSetRollVelocity,...
             handles.btnRotateAxis1, handles.btnRotateAxis2,...
             handles.btnRotateBall1, handles.btnRotateBall2,...
             handles.btnSetHomePosition, handles.btnReturnHome,...
             handles.btnRunAll, handles.txtAngleRepose, ...
             handles.txtAxisVelocity, handles.txtRollVelocity...
             handles.txtAxisAngle1, handles.txtAxisAngle2, ...
             handles.txtRollAngle1, handles.txtRollAngle2, ...         
             ],'Enable','on');
    end 
    
end

        
    
    
% --- Executes on button press in btnDisconnect.
function btnDisconnect_Callback(hObject, eventdata, handles)
    global mySerialObj    
    
    fclose(mySerialObj);
    clear global mySerialObj;
    delete(instrfind);
    
    % enable connect button
    set([handles.btnConnect, handles.txtComPort], 'Enable', 'on');
    
    % disable all real time buttons
    set([handles.btnDisconnect, handles.btnSetAxisVelocity,...
         handles.btnSetRollVelocity,...
         handles.btnRotateAxis1, handles.btnRotateAxis2,...
         handles.btnRotateBall1, handles.btnRotateBall2,...
         handles.btnSetHomePosition, handles.btnReturnHome,...
         handles.btnRunAll, handles.txtAngleRepose, ...
         handles.txtAxisVelocity, handles.txtRollVelocity...
         handles.txtAxisAngle1, handles.txtAxisAngle2, ...
         handles.txtRollAngle1, handles.txtRollAngle2, ...
         ],'Enable','off');
end    
     

% --- Executes on button press in btnReturnHome.
function btnReturnHome_Callback(hObject, eventdata, handles)
% hObject    handle to btnReturnHome (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    global mySerialObj AXIS_MOTOR_ID ROLL_MOTOR_ID CURRENT_BALL_ANGLE CURRENT_AXIS_ANGLE
    set_mc_position(0, ROLL_MOTOR_ID, mySerialObj)
    set_mc_position(0, AXIS_MOTOR_ID, mySerialObj)
    CURRENT_BALL_ANGLE = 0;
    CURRENT_AXIS_ANGLE = 0;
end
    

% --- Executes on button press in btnRotateAxis1.
function btnRotateAxis1_Callback(hObject, eventdata, handles)
    global mySerialObj AXIS_MOTOR_ID CURRENT_AXIS_ANGLE
    angle = str2double(get(handles.txtAxisAngle1, 'string'));
    set_mc_position(angle, AXIS_MOTOR_ID, mySerialObj);
    time = abs(angle - CURRENT_AXIS_ANGLE)/360 / str2double(get(handles.txtAxisVelocity, 'string')) * 60;
    pause(time);
    CURRENT_AXIS_ANGLE = angle;
end
    
    
% --- Executes on button press in btnRotateAxis2.
function btnRotateAxis2_Callback(hObject, eventdata, handles)
    global mySerialObj AXIS_MOTOR_ID CURRENT_AXIS_ANGLE
    angle = str2double(get(handles.txtAxisAngle2, 'string'));
    set_mc_position(angle, AXIS_MOTOR_ID, mySerialObj);
    time = abs(angle - CURRENT_AXIS_ANGLE)/360 / str2double(get(handles.txtAxisVelocity, 'string')) * 60;
    pause(time);
    CURRENT_AXIS_ANGLE = angle;
end
    
% --- Executes on button press in btnRotateBall1.
function btnRotateBall1_Callback(hObject, eventdata, handles)
    global mySerialObj ROLL_MOTOR_ID CURRENT_BALL_ANGLE

    %Capture angle and repose information
    angle1 = str2double(get(handles.txtRollAngle1, 'string'));
    repose1 = str2double(get(handles.txtAngleRepose, 'string'));
    
    % Find distance to travel
    deltaDistance = abs(CURRENT_BALL_ANGLE - angle1) + repose1;
    
    %Check direction of repose
    if (angle1 < CURRENT_BALL_ANGLE)
        repose1 = -repose1;
    end
    angle1 = angle1 + repose1;
    
    % Read in velocity of travel
    velocityR = str2double(get(handles.txtRollVelocity, 'string'));

    % Compute a guess to how much time this will take for the tumbler to
    % move (t = v/d)
    time = (deltaDistance/360) / velocityR * 60;
    time = time + 1;
    
    % Command tumbler to move to angle + repose
    set_mc_position(angle1, ROLL_MOTOR_ID, mySerialObj)
    
    % Wait for first motion to happen
    pause(time);
    
    % Move to actual desired position
    angle1 = str2double(get(handles.txtRollAngle1, 'string'));
    time = (repose1/360) / velocityR * 60;
    time = time + 1;
    set_mc_position(angle1, ROLL_MOTOR_ID, mySerialObj)
    pause(time);
    CURRENT_BALL_ANGLE = angle1;
end
    
% --- Executes on button press in btnRotateBall2.
function btnRotateBall2_Callback(hObject, eventdata, handles)
    global mySerialObj ROLL_MOTOR_ID CURRENT_BALL_ANGLE

    %Capture angle and repose information
    angle2 = str2double(get(handles.txtRollAngle2, 'string'));
    repose1 = str2double(get(handles.txtAngleRepose, 'string'));
    
    % Find distance to travel
    deltaDistance = abs(CURRENT_BALL_ANGLE - angle2) + repose1;
    
    %Check direction of repose
    if (angle2 < CURRENT_BALL_ANGLE)
        repose1 = -repose1;
    end
    angle2 = angle2 + repose1;
    
    % Read in velocity of travel
    velocityR = str2double(get(handles.txtRollVelocity, 'string'));

    % Compute a guess to how much time this will take for the tumbler to
    % move (t = v/d)
    time = (deltaDistance/360) / velocityR * 60;
    time = time + 1;
    
    % Command tumbler to move to angle + repose
    set_mc_position(angle2, ROLL_MOTOR_ID, mySerialObj)
    
    % Wait for first motion to happen
    pause(time);
    
    % Move to actual desired position
    angle2 = str2double(get(handles.txtRollAngle2, 'string'));
    time = (repose1/360) / velocityR * 60;
    time = time + 1;
    set_mc_position(angle2, ROLL_MOTOR_ID, mySerialObj)
    pause(time);
    CURRENT_BALL_ANGLE = angle2;
end
    
    % --- Executes on button press in btnSetRollVelocity.
function btnSetRollVelocity_Callback(hObject, eventdata, handles)
    global mySerialObj ROLL_MOTOR_ID
    velocityR = str2double(get(handles.txtRollVelocity, 'string'));
    set_mc_velocity(velocityR, ROLL_MOTOR_ID, mySerialObj);
end
    
% --- Executes on button press in btnSetAxisVelocity.
function btnSetAxisVelocity_Callback(hObject, eventdata, handles)
    global mySerialObj AXIS_MOTOR_ID
    velocityA = str2double(get(handles.txtAxisVelocity, 'string'));
    set_mc_velocity(velocityA, AXIS_MOTOR_ID, mySerialObj);
end
    
% --- Executes on button press in btnSetHomePosition.
function btnSetHomePosition_Callback(hObject, eventdata, handles)
    global mySerialObj AXIS_MOTOR_ID ROLL_MOTOR_ID CURRENT_BALL_ANGLE CURRENT_AXIS_ANGLE
    CURRENT_BALL_ANGLE = 0;
    CURRENT_AXIS_ANGLE = 0;
    mc_resetpos(AXIS_MOTOR_ID, mySerialObj);
    mc_resetpos(ROLL_MOTOR_ID, mySerialObj);
    velocityR = str2double(get(handles.txtRollVelocity, 'string'));
    velocityA = str2double(get(handles.txtAxisVelocity, 'string'));
    set_mc_velocity(velocityR, ROLL_MOTOR_ID, mySerialObj);
    set_mc_velocity(velocityA, AXIS_MOTOR_ID, mySerialObj);
end

% --- Executes on button press in btnRunAll.
function btnRunAll_Callback(hObject, eventdata, handles)
    % ********* Axis 1 Motion *********
        global mySerialObj AXIS_MOTOR_ID ROLL_MOTOR_ID CURRENT_BALL_ANGLE CURRENT_AXIS_ANGLE
        angle = str2double(get(handles.txtAxisAngle1, 'string'));
        set_mc_position(angle, AXIS_MOTOR_ID, mySerialObj)
        time = abs(angle - CURRENT_AXIS_ANGLE)/360 / str2double(get(handles.txtAxisVelocity, 'string')) * 60;
        pause(time);
        CURRENT_AXIS_ANGLE = angle;
    % ********* Ball 1 Motion *********
        %Capture angle and repose information
        angle1 = str2double(get(handles.txtRollAngle1, 'string'));
        repose1 = str2double(get(handles.txtAngleRepose, 'string'));

        % Find distance to travel
        deltaDistance = abs(CURRENT_BALL_ANGLE - angle1) + repose1;

        %Check direction of repose
        if (angle1 < CURRENT_BALL_ANGLE)
            repose1 = -repose1;
        end
        angle1 = angle1 + repose1;

        % Read in velocity of travel
        velocityR = str2double(get(handles.txtRollVelocity, 'string'));

        % Compute a guess to how much time this will take for the tumbler to
        % move (t = v/d)
        time = (deltaDistance/360) / velocityR * 60;
        time = time + 1;

        % Command tumbler to move to angle + repose
        set_mc_position(angle1, ROLL_MOTOR_ID, mySerialObj)

        % Wait for first motion to happen
        pause(time);

        % Move to actual desired position
        angle1 = str2double(get(handles.txtRollAngle1, 'string'));
        time = (repose1/360) / velocityR * 60;
        time = time + 1;
        set_mc_position(angle1, ROLL_MOTOR_ID, mySerialObj)
        pause(time);
        CURRENT_BALL_ANGLE = angle1;
    % ********* Axis 2 Motion *********
        angle = str2double(get(handles.txtAxisAngle2, 'string'));
        set_mc_position(angle, AXIS_MOTOR_ID, mySerialObj)
        time = abs(angle - CURRENT_AXIS_ANGLE)/360 / str2double(get(handles.txtAxisVelocity, 'string')) * 60;
        pause(time);
        CURRENT_AXIS_ANGLE = angle;
        
    % ********* Ball 2 Motion *********
        %Capture angle and repose information
        angle2 = str2double(get(handles.txtRollAngle2, 'string'));
        repose1 = str2double(get(handles.txtAngleRepose, 'string'));

        % Find distance to travel
        deltaDistance = abs(CURRENT_BALL_ANGLE - angle2) + repose1;

        %Check direction of repose
        if (angle2 < CURRENT_BALL_ANGLE)
            repose1 = -repose1;
        end
        angle2 = angle2 + repose1;

        % Read in velocity of travel
        velocityR = str2double(get(handles.txtRollVelocity, 'string'));

        % Compute a guess to how much time this will take for the tumbler to
        % move (t = v/d)
        time = (deltaDistance/360) / velocityR * 60;
        time = time + 1;

        % Command tumbler to move to angle + repose
        set_mc_position(angle2, ROLL_MOTOR_ID, mySerialObj)

        % Wait for first motion to happen
        pause(time);

        % Move to actual desired position
        angle2 = str2double(get(handles.txtRollAngle2, 'string'));
        time = (repose1/360) / velocityR * 60;
        time = time + 1;
        set_mc_position(angle2, ROLL_MOTOR_ID, mySerialObj)
        pause(time);
        CURRENT_BALL_ANGLE = angle2;

end


% --- Executes on button press in btnLoadSampleScript.
function btnLoadSampleScript_Callback(hObject, eventdata, handles)
    open Tumber_scripted_example.m
end




function txtangleRepose_Callback(hObject, eventdata, handles)
end

% --- Executes during object creation, after setting all properties.
function txtangleRepose_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
end

function txt_Callback(hObject, eventdata, handles)
end

% --- Executes during object creation, after setting all properties.
function txt_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
end


function edit11_Callback(hObject, eventdata, handles)
end

% --- Executes during object creation, after setting all properties.
function edit11_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
end


function txtComPort_Callback(hObject, eventdata, handles)
end

% --- Executes during object creation, after setting all properties.
function txtComPort_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
end

function txtAxisAngle1_Callback(hObject, eventdata, handles)
end

% --- Executes during object creation, after setting all properties.
function txtAxisAngle1_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
end


function txtAngleRepose_Callback(hObject, eventdata, handles)
end

% --- Executes during object creation, after setting all properties.
function txtAngleRepose_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
end


function txtAxisAngle2_Callback(hObject, eventdata, handles)
end

% --- Executes during object creation, after setting all properties.
function txtAxisAngle2_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
end


function txtRollAngle1_Callback(hObject, eventdata, handles)
end

% --- Executes during object creation, after setting all properties.
function txtRollAngle1_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
end


function txtVelocity1_Callback(hObject, eventdata, handles)
end

% --- Executes during object creation, after setting all properties.
function txtVelocity1_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
end


function txtRollAngle2_Callback(hObject, eventdata, handles)
end

% --- Executes during object creation, after setting all properties.
function txtRollAngle2_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
end

function txtVelocity2_Callback(hObject, eventdata, handles)
end

% --- Executes during object creation, after setting all properties.
function txtVelocity2_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
end

function txtAxisVelocity_Callback(hObject, eventdata, handles)
end

% --- Executes during object creation, after setting all properties.
function txtAxisVelocity_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
end

function pushbutton8_Callback(hObject, eventdata, handles)
    fprintf('pb8\n');
end

function txtRollVelocity_Callback(hObject, eventdata, handles)
end

function txtRollVelocity_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
end